import 'package:flutter/material.dart';
import 'package:flutter_custom_form_component/widget/const.dart';

class BoxDecorations {
  late final BoxDecoration _active, _box, _error;

  BoxDecorations(
      {final BoxDecoration? active,
      final BoxDecoration? box,
      final BoxDecoration? error}) {
    _active = active ?? _decoration(_Type.active);
    _box = box ?? _decoration(_Type.box);
    _error = error ?? _decoration(_Type.error);
  }

  BoxDecoration _decoration(final _Type type) => BoxDecoration(
      border: Border.all(color: type.color, width: 0.5),
      borderRadius: BorderRadius.circular(8.0),
      color: colorWhite);

  BoxDecoration get active => _active;

  BoxDecoration get box => _box;

  BoxDecoration get error => _error;
}

enum _Type { active, box, error }

extension _Ext on _Type {
  Color get color {
    switch (this) {
      case _Type.active:
        return colorBlue;
      case _Type.box:
        return colorBlack;
      case _Type.error:
        return colorRed;
    }
  }
}
