import 'package:flutter/material.dart';
import 'package:flutter_custom_form_component/widget/const.dart';

class TextStyles {
  late final TextStyle _active, _error, _hint, _text;

  TextStyles(
      {final TextStyle? active,
      final TextStyle? error,
      final TextStyle? hint,
      final TextStyle? text}) {
    _active = active ?? _style(_Type.active);
    _error = error ?? _style(_Type.error);
    _hint = hint ?? _style(_Type.hint);
    _text = text ?? _style(_Type.text);
  }

  TextStyle _style(final _Type type) => TextStyle(
      color: type.color,
      fontFamily: 'Circular Std',
      fontSize: 16.0,
      fontWeight: FontWeight.w400);

  TextStyle get active => _active;

  TextStyle get error => _error;

  TextStyle get hint => _hint;

  TextStyle get text => _text;
}

enum _Type { active, error, hint, text }

extension _Ext on _Type {
  Color get color {
    switch (this) {
      case _Type.active:
        return colorBlue;
      case _Type.error:
        return colorRed;
      case _Type.hint:
        return colorGrey;
      case _Type.text:
        return colorBlack;
    }
  }
}
